<?php

namespace Commocore\C64Unit\Symlinker\CoreInstallers\Strategy;

use Commocore\C64Unit\Symlinker\Configuration;

class DasmCoreInstaller implements CoreInstallerInterface
{
    public function getName()
    {
        return Configuration::DASM;
    }

    /**
     * @param string $page
     * @return string
     */
    public function getContent($page)
    {
        return PHP_EOL .
            '; This file is automatically generated by Symlinker' . PHP_EOL . PHP_EOL .
            'coreBinaryLocation equ $' . $page . PHP_EOL .
            PHP_EOL .
            chr(9) . 'if c64unit_include == "definitions"' . PHP_EOL .
            chr(9) . chr(9) . 'include "cross-assemblers/dasm/symbols.asm"' . PHP_EOL .
            chr(9) . chr(9) . 'include "cross-assemblers/dasm/macros.asm"' . PHP_EOL .
            chr(9) . 'else if c64unit_include == "package"' . PHP_EOL .
            chr(9) . chr(9) . 'org coreBinaryLocation' . PHP_EOL .
            chr(9) . chr(9) . 'incbin "bin/core' . $page . '.bin"' . PHP_EOL .
            chr(9) . 'eif' . PHP_EOL;
    }
}
