<?php

namespace Commocore\C64Unit\Symlinker\CoreInstallers\Strategy;

use Commocore\C64Unit\Symlinker\Configuration;

class KickAssemblerCoreInstaller implements CoreInstallerInterface
{
    public function getName()
    {
        return Configuration::KICK_ASSEMBLER;
    }

    /**
     * @param string $page
     * @return string
     */
    public function getContent($page)
    {
        return PHP_EOL .
            '// This file is automatically generated by Symlinker' . PHP_EOL . PHP_EOL .
            chr(9) . '.var coreBinaryLocation = $' . $page . PHP_EOL .
            PHP_EOL .
            chr(9) . '.import source "symbols.asm"' . PHP_EOL .
            chr(9) . '.import source "macros.asm"' . PHP_EOL .
            PHP_EOL .
            chr(9) . '.pc = coreBinaryLocation "c64unit"' . PHP_EOL .
            chr(9) . '.import binary "../../bin/core' . $page . '.bin"' . PHP_EOL;
    }
}
